﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Net.Sockets;
using System.Net;

namespace SocketAsyncOpWithTimeOut
{
    class Program
    {
        static void Main(string[] args)
        {
            //TestSocketBeginReceive();
            TestSocketBeginReceive2();
            Console.ReadKey();
        }

        #region Test Socket.BeginReceive2

        private static void TestSocketBeginReceive2()
        {
            Socket socket = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);
            byte[] content = Encoding.ASCII.GetBytes("Hello world");

            IPAddress ip = Dns.Resolve("www.google.com").AddressList[0];
            IPEndPoint receiver = new IPEndPoint(ip, 80);

            socket.BeginSendTo(content, 0, content.Length, SocketFlags.None, receiver, SendToCb2, socket);
            Console.WriteLine("Sent bytes: " + content.Length);
        }

        private static void SendToCb2(IAsyncResult ar)
        {
            var socket = ar.AsyncState as Socket;
            socket.EndSendTo(ar);
            byte[] buffer = new byte[1024];

            AsyncResultWithTimeout receiveAr = socket.BeginReceive2(2000, buffer, 0, buffer.Length, SocketFlags.None, null, null);
            receiveAr.AsyncWaitHandle.WaitOne();
            if (receiveAr.TimedOut)
            {
                Console.WriteLine("Operation timed out.");
            }
            else
            {
                int received = socket.EndReceive(ar);
                Console.WriteLine("Received bytes: " + received);
            }
        }

        #endregion
        #region Test Socket.BeginReceive

        private static void TestSocketBeginReceive()
        {
            Socket socket = new Socket(AddressFamily.InterNetwork,
                SocketType.Dgram, ProtocolType.Udp);
            byte[] content = Encoding.ASCII.GetBytes("Hello world");

            IPAddress ip = Dns.Resolve("www.google.com").AddressList[0];
            IPEndPoint receiver = new IPEndPoint(ip, 80);

            socket.BeginSendTo(content, 0, content.Length, SocketFlags.None, 
                receiver, SendToCb, socket);
            Console.WriteLine("Sent bytes: " + content.Length);
        }

        private static void SendToCb(IAsyncResult ar)
        {
            var socket = ar.AsyncState as Socket;
            socket.EndSendTo(ar);
            byte[] buffer = new byte[1024];

            IAsyncResult receiveAr = socket.BeginReceive(buffer, 0, buffer.Length,
                SocketFlags.None, null, null);
            int received = socket.EndReceive(receiveAr);
            Console.WriteLine("Received bytes: " + received);
        } 
        #endregion
    }
}
